import { Address, Chain, PublicClient, TransactionSerializable, Transport } from 'viem';
import { IUITransaction } from '@dynamic-labs/types';
import { Eip1559FeeFeed } from '../utils/Eip1559FeeFeed';
type ViemUiTransactionProps = {
    account: Address;
    transaction: TransactionSerializable;
    onSubmit: (transaction: TransactionSerializable) => Promise<string>;
    publicClient: PublicClient<Transport, Chain>;
};
export declare class ViemUiTransaction extends Eip1559FeeFeed implements IUITransaction {
    chain: string;
    receipt: string | undefined;
    private transaction;
    private address;
    protected publicClient: PublicClient<Transport, Chain>;
    private onSubmit;
    constructor({ transaction, onSubmit, publicClient, account, }: ViemUiTransactionProps);
    validateAddressFormat: (address: string) => boolean;
    parse: (input: string) => bigint;
    format: (value: bigint, { precision }?: import("@dynamic-labs/types").IUITransactionFormatOptions) => string;
    get to(): Address | undefined;
    set to(toAddress: Address | undefined);
    get from(): `0x${string}`;
    get value(): bigint | undefined;
    set value(value: bigint | undefined);
    get data(): `0x${string}` | undefined;
    submit(): Promise<string>;
    getBalance(): Promise<bigint>;
    estimateGas(): Promise<bigint>;
    private convertBigIntToHex;
    estimateL1Fee(): Promise<bigint>;
    set maxFeePerGas(value: bigint);
    set maxPriorityFeePerGas(value: bigint);
}
export {};
